package soln;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.DisplayMode;
import java.awt.Graphics2D;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.Scanner;

import javax.swing.JFrame;

import type.lang.UniPanel;
import type.lib.CreditCard;
import type.lib.Fraction;
import type.lib.Investment;
import type.lib.Stock;

public class Labtest10_Sec01_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * GOAL: understand the difference between methods that return a
		 * reference to an aggregate part and those that return a reference to a
		 * copy of the aggregate part
		 */

		/**
		 * [2 marks] Step 1: Use the getRandom() method of Investment to obtain
		 * a randomly-created Investment object. Print out the object to
		 * System.out once it has been created. Read the API for the Investment
		 * class definition in order to understand what an investment
		 * encapsulates.
		 * 
		 */

		Investment inv = Investment.getRandom();
		System.out.println(inv);

		/**
		 * [2 marks] Step 2: Use the appropriate accessor method on the
		 * Investment object in order to determine the total current value of
		 * the investment. The book value is the price paid per stock and the
		 * quantity is the number of stocks purchased. Once you have obtained
		 * the value of this investment, print the value to System.out.
		 * 
		 * Bonus: (do this at the end and only if you have adequate time) format
		 * the value nicely with two decimal places using the services of printf
		 */
		double value = inv.getBookValue() * inv.getQty();
		System.out.println("Value of the investment: " + value);

		/**
		 * [2 marks] Step 3: Use the appropriate accessor method on the
		 * Investment object in order to determine the Stock that is part of the
		 * Investment object. Once you have obtained a reference to the Stock
		 * object, use the appropriate method in order to determine the current
		 * price of the stock. Determine the cost at the current price if one
		 * wanted to buy the same quantity of that stock as the quantity in the
		 * investment. Once you have obtained this cost, print it to System.out.
		 */

		Stock stock1 = inv.getStock();
		double cost = stock1.getPrice() * inv.getQty();
		System.out.println("Current Cost of this investment: " + cost);

		/**
		 * [1 mark] Step 4: Your investment has increased in value if the cost
		 * of the investment is less than the current cost of the investment.
		 * Has the investment increased in value? Print the result to
		 * System.out.
		 */

		boolean hasValueIncreased = cost > value;
		System.out.println("Has value increased? " + hasValueIncreased);

		/**
		 * [2 marks] Step 5: Use the appropriate accessor method on the
		 * Investment object in order to obtain a reference to its Stock obhect.
		 * Invoke the appropriate mutator on that Stock object to set the symbol
		 * to ".ZZ". If the symbol already happens to be ".ZZ", change it to
		 * ".AA" instead. Once this has been done, print out the Investment
		 * object to System.out. Did the investment object change when the
		 * composite element (its Stock object) was changed? Your will have the
		 * opportunity to provide your answer in a subsequent part.
		 */

		if (stock1.getSymbol().equals(".ZZ")) {
			stock1.setSymbol(".AA");
		} else {
			stock1.setSymbol(".ZZ");
		}

		System.out.println(inv);

	}
}
